/*****************************************************************************
 * Copyright (c) 2019 CEA LIST, and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Nicolas FAUVERGUE (CEA LIST) nicolas.fauvergue@cea.fr - Initial API and implementation
 *
 *****************************************************************************/

package org.eclipse.papyrus.sysml16.diagram.common.util;

/**
 * List SysML 1.6 graphical element type ids
 */
public final class GraphicalSysMLServiceTypeUtil {

	public static final String ORG_ECLIPSE_PAPYRUS_SYSML16_PARAMETER_BORDER_ITEM = "org.eclipse.papyrus.sysml16di.Parameter_BorderItem"; //$NON-NLS-1$

	public static final String ORG_ECLIPSE_PAPYRUS_SYSML16_CONSTRAINT_LABEL = "org.eclipse.papyrus.sysml16di.Constraint_Label";//$NON-NLS-1$
	
	public static final String ORG_ECLIPSE_PAPYRUS_SYSML16_CONSTRAINT_PROPERTY_COMPOSITE = "org.eclipse.papyrus.sysml16di.ConstraintPropertyComposite"; //$NON-NLS-1$
	
	private GraphicalSysMLServiceTypeUtil() {
	}

}
